// TCP/IPUDP̎ɂ𗧂ĉ 
// 02/09/10 HDL

#include <windows.h>
#include <winsock.h>
#include <stdio.h>
#include <stdlib.h>

#include "TcpUdp_def.h"
#include "TcpUdp_func.h"
#include "resource.h"

int TCP_STATE = 0; // TCPFP
int UDP_STATE = 0; // UDPFP

char sbuf[150];
int SND_BTN = 0;

struct sockaddr_in  UdpMyAddr; /* ڑAhX */
struct sockaddr_in  UdpDsAddr; /* ڑAhX */

BYTE publicIPaddr[5];

BOOL CALLBACK dlgproc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{	
	char szMyIP[256];
	char szEpnIP[256];
	char szMyPort[256];
	char szDsPort[256];
	static char szHostName[256];
	int myPort, dsPort;

	static SOCKET s = 0;

	switch(message)
	{
	case WM_INITDIALOG:
		{
			GetHostName( szHostName, szMyIP );
			//PC(̃vO𓮍)IPAhX
			SetDlgItemText(hDlg, ID_PC_IP, szMyIP);
			SetDlgItemText(hDlg, ID_PC_PORT, "1234");
			//EPNIPAhX
			SetDlgItemText(hDlg, ID_EPN_IP, "192.168.0.254");
			SetDlgItemText(hDlg, ID_EPN_PORT, "1234");
			break;
		}


	case WM_COMMAND:
		{
			switch(wParam) 
			{
			case ID_UDP_OPEN:
				if( !UDP_STATE ) {
					TCP_STATE = 0; UDP_STATE = 1;
					ZeroMemory( szEpnIP, sizeof(szEpnIP));
					GetDlgItemText( hDlg, ID_PC_PORT,  szMyPort, 256 );
					GetDlgItemText( hDlg, ID_EPN_PORT, szDsPort, 256 );
					GetDlgItemText( hDlg, ID_EPN_IP,   szEpnIP,  256 );

					myPort = atoi(szMyPort);
					dsPort = atoi(szDsPort);
					s = UdpOpen( myPort, dsPort, szEpnIP );
				}
				else
					printf("---I[v---\n");

				break;
			case ID_UDP_CLOSE:
				UDP_STATE = 0;
				shutdown(s, 0);
				closesocket(s);
				WSACleanup();
				break;

			case ID_TCP_OPEN:
				if( !TCP_STATE ) {
					TCP_STATE = 1; UDP_STATE = 0;
					ZeroMemory( szEpnIP, sizeof(szEpnIP));
					GetDlgItemText( hDlg, ID_PC_PORT,  szMyPort, 256 );
//					GetDlgItemText( hDlg, ID_EPN_PORT, szDsPort, 256 );
					GetDlgItemText( hDlg, ID_EPN_IP,   szEpnIP,  256 );

					myPort = atoi(szMyPort);
//					dsPort = atoi(szDsPort);
					s = TcpOpen( myPort, szEpnIP );
				}
				else
					printf("---I[v---\n");
				break;

			case ID_TCP_CLOSE:
				TCP_STATE = 0;
				shutdown(s, 0);
				closesocket(s);
				WSACleanup();
				break;
			case ID_SND_BTN:
				ZeroMemory(sbuf, sizeof(sbuf));
				GetDlgItemText( hDlg, ID_SND, sbuf, 150 );
				SND_BTN = 1;
				break;
			}
			break;
		}

	case WM_TIMER:
		{
			break;
		}
	case WM_CLOSE:
		{
			DestroyWindow( hDlg );
			PostQuitMessage(0);
			break;
		}
	} 
	
	return false;
}

int main()
 {
	HINSTANCE hInstance = (HINSTANCE)GetWindowLong(HWND_DESKTOP,GWL_HINSTANCE);

	MSG msg;

	HWND hDlg = CreateDialog( hInstance, "DLG_DATA", 0, (DLGPROC)dlgproc );

//	SetTimer( hDlg, 111, 1000, NULL );

    while(GetMessage( &msg, NULL, 0, 0) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
    }

//	KillTimer(hDlg,111);

	return (int)msg.wParam;
}
